## Serialization

Pret ships the code from your kernel using a modified version of the dill library. In theory,
this means that you can serialize any Python object, including classes, functions, and
instances of classes. In practice, there are some limitations, which we will discuss in this
section.

Functions are difficult to serialize, since they are composed of multiple objects, including
a `code` object, whose API changes between Python versions, in particular the generated bytecode.

To work around this, for Python versions older than 3.11 (the Python version of pyodide), functions are serialized by their source code, which is then recompiled during deserialization in the browser. Retrieving the source code 
of a function is not always possible, in particular for lambda functions, which will make the
serialization fail. In any case, prefer using Python 3.11 to maximize compatibility between kernel and client sessions.

For older version of Python, it is possible decompile lambda functions bytecode and retrieve an approximation
of their original source code (as named functions), using `pycdc`. This functionality is experimental.

